<template>
    <v-container class="computer text-center" style="margin-top: 60px">
        <ol style="text-align: justify">
            <li>Andrew bought the computer which was three hundred Euros less than the PC which has a processor that is 0.4 MHz more powerful than the one which has a 21.5' screen.</li>
            <li>The five computers aren: the one chosen by Andrew (which doesn't have the 27' screen), the one which has the 2.0-MHz processor, the computer that has a 250 GB HD, the one which has a price of 1,149 Euros and the computer (which doesn't have the 15' screen) that has the HD bigger than the one chosen by Andrew but smaller than that the one which has the 2.7 MHz processor.</li>
            <li>The computer with the 320 Gb HD has either the 2.0 or the 2.3 MHz processor.The processor of the computer which has the 15' screen is more powerful than the one in the computer that costs 999 euros but less powerful than the processor that is included in the 1,349 Euros computer.</li>
            <li>The computer that has the 27' screen doesn't have the 320 Gb hard drive. The 500 GB HD is included in the computer that has a more powerful professor and a larger size screen than the one which costs 699 euros (which doesn't include the 320 Gb HD).</li>
        </ol>
		<br />
        <v-simple-table fixed-header>
            <tbody>
            <!---------- Ligne 1/4 ------------>
            <tr>
                <td colspan="5" class="nope">&nbsp;</td>
                <th colspan="5" style="text-align: center">Processor</th>
                <th colspan="5" style="text-align: center">Hard Disk</th>
                <th colspan="5" style="text-align: center" class="ext-border-right">Price</th>
            </tr>
            <tr>
                <td v-for="(nope, i) in model.cols[0].children" :key="i"
                    class="nope">
                    &nbsp;
                </td>
                <td v-for="(film, i) in model.cols[0].children" :key="film+i"
                    class="vertical ext-border-bottom"
                    :class="{ 'ext-border-right': i === model.cols[0].children.length - 1}">
                    {{ film }}
                </td>
                <td v-for="(day, i) in model.cols[1].children" :key="day+i"
                    class="vertical ext-border-bottom"
                    :class="{ 'ext-border-right': i === model.cols[1].children.length - 1}">
                    {{ day }}
                </td>
                <td v-for="(time, i) in model.cols[2].children" :key="time+i"
                    class="vertical ext-border-bottom"
                    :class="{ 'ext-border-right': i === model.cols[2].children.length - 1}">
                    {{ time }}
                </td>
            </tr>
            <!---------- Ligne 2/4 ------------>
            <th :rowspan="model.rows[0].children.length + 1" class="vertical">{{ model.rows[0].title }}</th>
            <tr v-for="child in model.rows[0].children" :key="child">
                <td colspan="4" class="text-lg-right ext-border-right">{{ child }}</td>
                <td v-for="(field, i) in model.data[model.rows[0].title][child][model.cols[0].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[0].title][child][model.cols[0].title][i] = v"/>
                </td>
                <td v-for="(field, i) in model.data[model.rows[0].title][child][model.cols[1].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[0].title][child][model.cols[1].title][i] = v"/>
                </td>
                <td v-for="(field, i) in model.data[model.rows[0].title][child][model.cols[2].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[0].title][child][model.cols[2].title][i] = v"/>
                </td>
            </tr>
            <!---------- Ligne 3/4 ------------>
            <th :rowspan="model.rows[1].children.length + 1" class="vertical">{{ model.rows[1].title }}</th>
            <tr v-for="child in model.rows[1].children" :key="child">
                <td colspan="4" class="text-lg-right ext-border-right">{{ child }}</td>
                <td v-for="(field, i) in model.data[model.rows[1].title][child][model.cols[0].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[1].title][child][model.cols[0].title][i] = v"/>
                </td>
                <td v-for="(field, i) in model.data[model.rows[1].title][child][model.cols[1].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[1].title][child][model.cols[1].title][i] = v"/>
                </td>
            </tr>
            <!---------- Ligne 4/4 ------------>
            <th :rowspan="model.rows[2].children.length + 1" class="vertical">{{ model.rows[2].title }}</th>
            <tr v-for="child in model.rows[2].children" :key="child">
                <td colspan="4" class="text-lg-right ext-border-right">{{ child }}</td>
                <td v-for="(field, i) in model.data[model.rows[2].title][child][model.cols[0].title]" :key="i"
                    style="text-align: center">
                    <selector2 :value="field"
                               @input="(v) => model.data[model.rows[2].title][child][model.cols[0].title][i] = v"/>
                </td>
            </tr>
            </tbody>
        </v-simple-table>
        <v-alert v-show="satisfiable != null"
                 :type="satisfiable ? 'success' : 'error'">
            {{ satisfiable ? "Well done, it's satisfiable" : "Sorry, it's not satisfiable" }}
        </v-alert>
        <v-btn @click="submit" color="success" class="mt-4">Submit</v-btn>
    </v-container>
</template>

<script>
import Selector2 from "@/components/Selector2.component";
import Services from "@/services";

export default {
    name: "Computer",
    components: { Selector2 },
    data: () => ({
        satisfiable: null,
        model: {
            cols: [
                {
                    title: "Processor",
                    children: ["2.0 MHz", "2.3 MHz", "2.5 MHz", "2.7 MHz", "3.1 MHz"]
                },
                {
                    title: "Hard Disk",
                    children: ["250 Gb", "320 Gb", "500 Gb", "750 Gb", "1024 Gb"]
                },
                {
                    title: "Price",
                    children: ["$699", "$999", "$1.149", "$1.349", "$1.649"]
                },
            ],
            rows: [
                {
                    title: "Monitor",
                    children: ["13'", "15'", "15.6'", "21.5'", "27'"]
                },
                {
                    title: "Price",
                    children: ["$699", "$999", "$1.149", "$1.349", "$1.649"]
                },
                {
                    title: "Hard Disk",
                    children: ["250 Gb", "320 Gb", "500 Gb", "750 Gb", "1024 Gb"]
                },
            ],
            data: {}
        }
    }),
    created() {
        for (let row of this.model.rows) {
            this.model.data[row.title] = {};
            for (let rowChildren of row.children) {
                this.model.data[row.title][rowChildren] = {};

                for (let col of this.model.cols) {
                    if (row.title === col.title) break;
                    this.model.data[row.title][rowChildren][col.title] = {};
                    for (let colChildren of col.children) {
                        this.model.data[row.title][rowChildren][col.title][colChildren] = null;
                    }
                }
            }
        }
    },
    methods: {
        async submit() {
            let res = await Services.pb3(this.model.data);
            this.satisfiable = res.satisfiable;
        }
    }
}
</script>

<style scoped>
.nope {
	visibility: hidden;
}

th {
	color: white;
	font-size: 18px !important;
	background-color: black;
	padding: 2px 7px;
	/*border: 3px solid black;*/
	/*text-align: center;*/
}

td {
	border: 1px solid lightgray;
}

td:not(.text-lg-right) {
	padding: 0 3px !important;
}

.ext-border-right, tr:not(:nth-child(2)) td:nth-child(5n+1), tr:first-child td:nth-child(5n+1) {
	border-right: 3px solid black !important;
}

tr:nth-child(6n+2) td, .ext-border-bottom {
	border-bottom: 3px solid black !important;
}

tr:nth-child(2) td:nth-child(6){
	border-left: 3px solid black !important;
}

tr:nth-child(4) td:first-child {
	border-top: 3px solid black !important;
}


/*.vertical {*/
/*	writing-mode: tb-rl;*/
/*	-webkit-transform: rotate(180deg);*/
/*	-moz-transform: rotate(180deg);*/
/*	-o-transform: rotate(180deg);*/
/*	-ms-transform: rotate(180deg);*/
/*	transform: rotate(180deg);*/
/*}*/
</style>